OGRE-Next: Ogre::GL3PlusTexBufferEmulatedPacked Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::GL3PlusTexBufferEmulatedPacked Class Referencefinal

`#include <OgreGL3PlusTexBufferEmulatedPacked.h>`

Inheritance diagram for Ogre::GL3PlusTexBufferEmulatedPacked:
[legend]

## Public Member Functions
| GL3PlusTexBufferEmulatedPacked (size_t internalBufStartBytes, size_t numElements, uint32 bytesPerElement, uint32 numElementsPadding, BufferType bufferType, void *initialData, bool keepAsShadow, VaoManager *vaoManager, GL3PlusBufferInterface *bufferInterface, PixelFormatGpu pf)
| ~GL3PlusTexBufferEmulatedPacked () override
void | _bindBufferDirectly (uint16 slot, size_t offset, size_t sizeBytes) override
| To be overriden only by GL3+.
void | bindBufferCS (uint16 slot, size_t offset=0, size_t sizeBytes=0) override
void | bindBufferDS (uint16 slot, size_t offset=0, size_t sizeBytes=0) override
void | bindBufferGS (uint16 slot, size_t offset=0, size_t sizeBytes=0) override
void | bindBufferHS (uint16 slot, size_t offset=0, size_t sizeBytes=0) override
void | bindBufferPS (uint16 slot, size_t offset=0, size_t sizeBytes=0) override
void | bindBufferVS (uint16 slot, size_t offset=0, size_t sizeBytes=0) override
| Binds the texture buffer to the given slot in the Vertex/Pixel/Geometry/Hull/Domain/Compute Shader.
Public Member Functions inherited from Ogre::TexBufferPacked
| TexBufferPacked (size_t internalBufferStartBytes, size_t numElements, uint32 bytesPerElement, uint32 numElementsPadding, BufferType bufferType, void *initialData, bool keepAsShadow, VaoManager *vaoManager, BufferInterface *bufferInterface, PixelFormatGpu pf)
BufferPackedTypes | getBufferPackedType () const override
| Useful to query which one is the derived class.
PixelFormatGpu | getPixelFormat () const
Public Member Functions inherited from Ogre::BufferPacked
| BufferPacked (size_t internalBufferStartBytes, size_t numElements, uint32 bytesPerElement, uint32 numElementsPadding, BufferType bufferType, void *initialData, bool keepAsShadow, VaoManager *vaoManager, BufferInterface *bufferInterface)
| Generic constructor.
virtual | ~BufferPacked ()
size_t | _getFinalBufferStart () const
size_t | _getInternalBufferStart () const
size_t | _getInternalNumElements () const
size_t | _getInternalTotalSizeBytes () const
void | _setBufferInterface (BufferInterface *bufferInterface)
| For internal use.
void | _setShadowCopy (void *copy)
| This will not delete the existing shadow copy so it can be used for other purposes if it is not needed call OGRE_FREE_SIMD( m->getShadowCopy(), MEMCATEGORY_GEOMETRY ) before calling this function.
void | advanceFrame ()
void | copyTo (BufferPacked *dstBuffer, size_t dstElemStart=0, size_t srcElemStart=0, size_t srcNumElems=std::numeric_limits< size_t >::max())
| Copies the contents of this buffer to another, using GPU -> GPU transfers.
BufferInterface * | getBufferInterface () const
BufferType | getBufferType () const
uint32 | getBytesPerElement () const
MappingState | getMappingState () const
| Returns the mapping state.
size_t | getNumElements () const
virtual BufferPacked * | getOriginalBufferType ()
| If this buffer has been reinterpreted from an UavBufferPacked, returns the original version, otherwise returns 'this'.
const void * | getShadowCopy () const
size_t | getTotalSizeBytes () const
bool | isCurrentlyMapped () const
| Returns whether the buffer is currently mapped.
void *RESTRICT_ALIAS_RETURN | map (size_t elementStart, size_t elementCount, bool bAdvanceFrame=true)
| Maps the specified region to a pointer the CPU can access.
AsyncTicketPtr | readRequest (size_t elementStart, size_t elementCount)
| Async data read request.
void | regressFrame ()
| Performs the opposite of.
void | unmap (UnmapOptions unmapOption, size_t flushStartElem=0, size_t flushSizeElem=0)
| Unmaps or flushes the region mapped with.
virtual void | upload (const void *data, size_t elementStart, size_t elementCount)
| Sends the provided data to the GPU.
Public Member Functions inherited from Ogre::GpuTrackedResource
virtual | ~GpuTrackedResource ()
virtual bool | isTextureGpu () const

## Constructor & Destructor Documentation

## ◆ GL3PlusTexBufferEmulatedPacked()

Ogre::GL3PlusTexBufferEmulatedPacked::GL3PlusTexBufferEmulatedPacked | ( | size_t | internalBufStartBytes,
|  | size_t | numElements,
|  | uint32 | bytesPerElement,
|  | uint32 | numElementsPadding,
|  | BufferType | bufferType,
|  | void * | initialData,
|  | bool | keepAsShadow,
|  | VaoManager * | vaoManager,
|  | GL3PlusBufferInterface * | bufferInterface,
|  | PixelFormatGpu | pf )

## ◆ ~GL3PlusTexBufferEmulatedPacked()

Ogre::GL3PlusTexBufferEmulatedPacked::~GL3PlusTexBufferEmulatedPacked | ( |  | ) |
| override

## Member Function Documentation

## ◆ _bindBufferDirectly()

void Ogre::GL3PlusTexBufferEmulatedPacked::_bindBufferDirectly | ( | uint16 | slot,
|  | size_t | offset,
|  | size_t | sizeBytes )
| overridevirtual

To be overriden only by GL3+.

Does the same as bindBufferXX but assumes the current GL_TEXTURE slot is already set.

Reimplemented from Ogre::TexBufferPacked.

## ◆ bindBufferCS()

void Ogre::GL3PlusTexBufferEmulatedPacked::bindBufferCS | ( | uint16 | slot,
|  | size_t | offset = 0,
|  | size_t | sizeBytes = 0 )
| overridevirtual

Implements Ogre::TexBufferPacked.

## ◆ bindBufferDS()

void Ogre::GL3PlusTexBufferEmulatedPacked::bindBufferDS | ( | uint16 | slot,
|  | size_t | offset = 0,
|  | size_t | sizeBytes = 0 )
| overridevirtual

Implements Ogre::TexBufferPacked.

## ◆ bindBufferGS()

void Ogre::GL3PlusTexBufferEmulatedPacked::bindBufferGS | ( | uint16 | slot,
|  | size_t | offset = 0,
|  | size_t | sizeBytes = 0 )
| overridevirtual

Implements Ogre::TexBufferPacked.

## ◆ bindBufferHS()

void Ogre::GL3PlusTexBufferEmulatedPacked::bindBufferHS | ( | uint16 | slot,
|  | size_t | offset = 0,
|  | size_t | sizeBytes = 0 )
| overridevirtual

Implements Ogre::TexBufferPacked.

## ◆ bindBufferPS()

void Ogre::GL3PlusTexBufferEmulatedPacked::bindBufferPS | ( | uint16 | slot,
|  | size_t | offset = 0,
|  | size_t | sizeBytes = 0 )
| overridevirtual

Implements Ogre::TexBufferPacked.

## ◆ bindBufferVS()

void Ogre::GL3PlusTexBufferEmulatedPacked::bindBufferVS | ( | uint16 | slot,
|  | size_t | offset = 0,
|  | size_t | sizeBytes = 0 )
| overridevirtual

Binds the texture buffer to the given slot in the Vertex/Pixel/Geometry/Hull/Domain/Compute Shader.

Remarks
  Not all RS API separate by shader stage. For best compatibility, don't assign two different buffers at the same slot for different stages (just leave the slot empty on the stages you don't use).

Parameters

  slot | The slot to asign this constant buffer. In D3D11 it's called 'slot'. In GLSL it's called it's called 'binding'
  offset | 0-based offset. It is possible to bind a region of the buffer. Offset needs to be aligned. You can query the RS capabilities for the alignment, however 256 bytes is the maximum allowed alignment per the OpenGL specification, making it a safe bet to hardcode.
  sizeBytes | Size in bytes to bind the tex buffer. When zero, binds from offset until the end of the buffer.

Implements Ogre::TexBufferPacked.

The documentation for this class was generated from the following file:

- OgreGL3PlusTexBufferEmulatedPacked.h